---
title: "Knative technical oversight committee"
linkTitle: "Technical oversight committee"
weight: 35
type: "docs"
---

The Knative Technical Oversight Committee (TOC) is responsible for cross-cutting
product and design decisions.

- [Charter](#charter)
- [Committee Mechanics](#committee-mechanics)
- [Committee Meeting](#committee-meeting)
- [Committee Members](#committee-members)

## Charter

- Technical Project Oversight, Direction & Delivery

  - Set the overall technical direction and roadmap of the project.

  - Resolve technical issues, technical disagreements and escalations within the
    project.

  - Set the priorities of individual releases to ensure coherency and proper
    sequencing.

  - Approve declaring a new long-term supported (LTS) Knative release.

  - Approve the creation and dissolution of working groups and approve
    leadership changes of working groups.

  - Create proposals based on TOC discussions and bring them to the relevant
    working groups for discussion.

  - Approve the creation/deletion of GitHub repositories, along with other
    high-level administrative issues around GitHub and our other tools.

- Happy Healthy Community

  - Establish and maintain the overall technical governance guidelines for the
    project.

  - Decide which sub-projects are part of the Knative project, including
    accepting new sub-projects and pruning existing sub-projects to maintain
    community focus

  - Ensure the team adheres to our
    [code of conduct](./CONTRIBUTING.md#code-of-conduct) and respects our
    [values](./VALUES.md).

  - Foster an environment for a healthy and happy community of developers and
    contributors.

## Committee Mechanics

The TOC’s work includes:

- Regular committee meetings to discuss hot topics, resulting in a set of
  published
  [meeting notes](https://docs.google.com/document/d/1hR5ijJQjz65QkLrgEhWjv3Q86tWVxYj_9xdhQ6Y5D8Q/edit#).

- Create, review, approve and publish technical project governance documents.

- Create proposals for consideration by individual working groups to help steer
  their work towards a common project-wide objective.

- Review/address/comment on project issues.

- Act as a high-level sounding board for technical questions or designs bubbled
  up by the working groups.

## Committee Meeting

Community members are encouraged to suggest topics for discussion ahead of the
TOC meetings, and are invited to observe these meetings and engage with the TOC
during the community feedback period at the end of each meeting.

| Artifact                   | Link                                                                                                                                                     |
| -------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------- |
| Google Group               | [knative-tech-oversight@googlegroups.com](https://groups.google.com/forum/#!forum/knative-tech-oversight)                                                |
| Community Meeting VC       | [meet.google.com/ffc-rypd-kih](https://meet.google.com/ffc-rypd-kih) <br>or dial in:<br>(US) +1 240-630-1102 PIN: 316262#                                |
| Community Meeting Calendar | Thursdays at 11:30a-12p <br>[Calendar](https://calendar.google.com/calendar/embed?src=google.com_18un4fuh6rokqf8hmfftm5oqq4%40group.calendar.google.com) |
| Meeting Notes              | [Notes](https://docs.google.com/document/d/1hR5ijJQjz65QkLrgEhWjv3Q86tWVxYj_9xdhQ6Y5D8Q/edit#heading=h.g47ptr8u5cov)                                     |
| Document Folder            | [Folder](https://drive.google.com/drive/folders/1_OHttsYLCVtX202aXNmJJrAHJ7BaXcu6)                                                                       |

## Committee Members

The members of the TOC are shown below. Membership in the TOC is determined by
the [Steering committee](./STEERING-COMMITTEE.md).

| &nbsp;                                                        | Member        | Company | Profile                                            |
| ------------------------------------------------------------- | ------------- | ------- | -------------------------------------------------- |
| <img width="30px" src="https://github.com/evankanderson.png"> | Evan Anderson | Google  | [@evankanderson](https://github.com/evankanderson) |
| <img width="30px" src="https://github.com/mattmoor.png">      | Matt Moore    | Google  | [@mattmoor](https://github.com/mattmoor)           |
| <img width="30px" src="https://github.com/vaikas-google.png"> | Ville Aikas   | Google  | [@vaikas-google](https://github.com/vaikas-google) |

---

Except as otherwise noted, the content of this page is licensed under the
[Creative Commons Attribution 4.0 License](https://creativecommons.org/licenses/by/4.0/),
and code samples are licensed under the
[Apache 2.0 License](https://www.apache.org/licenses/LICENSE-2.0).
